#!/usr/bin/perl
#
# mapxpand.pl - A tool for processing console map templates
# Copyright (C) 2006 Strahinya Radich <vilinkamen@mail.ru>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# The input file is basically the same as the default
# console map template:
#
#   0xNNNN <WHITESPACE> U+NNNN
#
# with the exception that you can write:
#
#   0xNNNN-0xNNNN <WHITESPACE> U+NNNN
#
# which expands to an appropriate list of pairs.

print "# Generated with mapxpand.pl\n";

while (<>) {
    $line = $_;
    if (/^0x([0-9,A-F,a-f]+)-0x([0-9,A-F,a-f]+)[\t ]+U\+([0-9,A-F,a-f]+)[\t ]*/) {
	($current,$end,$rep) = (hex $1,hex $2,hex $3);
	while ($current <= $end) {
	    printf "0x%03X\tU+%04X\n", $current++, $rep++;
	}
    } else {
	print $line;
    }
}
